/*********************************************************************
* Copyright (c) 2024 Eclipse Foundation.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
**********************************************************************/
package org.eclipsefoundation.membership.portal.api;

import org.eclipse.microprofile.rest.client.inject.RegisterRestClient;
import org.eclipsefoundation.membership.portal.model.SlackResponse;

import jakarta.ws.rs.Encoded;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.PathParam;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.MediaType;
import jakarta.ws.rs.core.Response;

/**
 * Slack API binding
 */
@Produces(MediaType.APPLICATION_JSON)
@RegisterRestClient(configKey = "slack-api")
public interface SlackAPI {

    /**
     * Used to POST back results to Slack after receiving a slash-command
     * 
     * @param path    The unique path generated by Slack at request time.
     * @param payload The payload with search results, or a not-founr message.
     * @return
     */
    @POST
    @Encoded
    @Path("{uniquePath}")
    Response postSlackPayload(@PathParam("uniquePath") String path, SlackResponse payload);
}
